/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package characters;

import com.jme3.animation.AnimChannel;
import com.jme3.animation.AnimControl;
import com.jme3.bullet.control.BetterCharacterControl;
import com.jme3.scene.Node;
import com.jme3.scene.Spatial;
import java.util.HashMap;

/**
 *
 * @author peter
 */
public abstract class AbstractCharacter extends Node {

    private AnimControl animControl;
    private BetterCharacterControl characterControl;
    private HashMap<String, AnimChannel> animChannels;
    private Spatial spatialForRotation;
    private Node nodeForMovement;
    private Boolean isAlive = true;

    public AbstractCharacter() {
        animChannels = new HashMap<String, AnimChannel>();

    }

    public Boolean getIsAlive() {
        return isAlive;
    }

    public void setIsAlive(Boolean isAlive) {
        this.isAlive = isAlive;
    }

    public abstract void update(float tpf);

    public abstract void animationHandler(float tpf);

    public abstract void walkHandler();

    public HashMap<String, AnimChannel> getAnimChannels() {
        return animChannels;
    }

    public AnimChannel getAnimChannel(String name) {
        if (animChannels.containsKey(name)) {
            return animChannels.get(name);
        } else {
            return null;
        }
    }

    public void setAnimChannels(HashMap<String, AnimChannel> animChannels) {
        this.animChannels = animChannels;
    }

    public void setAnimChannel(String name, AnimChannel animChannel) {
        this.animChannels.put(name, animChannel);
    }

    public AnimControl getAnimControl() {
        return animControl;
    }

    public void setAnimControl(AnimControl animControl) {
        this.animControl = animControl;
    }

    public BetterCharacterControl getCharacterControl() {
        return characterControl;
    }

    public void setCharacterControl(BetterCharacterControl characterControl) {
        this.characterControl = characterControl;
    }

    public Spatial getSpatialForRotation() {
        return spatialForRotation;
    }

    public void setSpatialForRotation(Spatial spatialForRotation) {
        this.spatialForRotation = spatialForRotation;
    }

    public Node getNodeForMovement() {
        return nodeForMovement;
    }

    public void setNodeForMovement(Node nodeForMovement) {
        this.nodeForMovement = nodeForMovement;
    }
}
