/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package characters.robot;

import characters.robot.CBotControllerCore;

/**
 *
 * @author Ján
 */
public class CBotController {
    //Imported machines

    private CBotControllerCore cbotcontrollercore;
    // scalar formal parameters
    private Integer maxMsrblDst;
    private Integer safeDstCl;
    private Integer safeDstMov;
    private Integer cleanRange;

    public CBotController(Integer maxMsrblDst, Integer safeDstCl, Integer safeDstMov, Integer cleanRange) {
        this.maxMsrblDst = maxMsrblDst;
        this.safeDstCl = safeDstCl;
        this.safeDstMov = safeDstMov;
        this.cleanRange = cleanRange;
        this.cbotcontrollercore = new CBotControllerCore(maxMsrblDst, safeDstCl, safeDstMov, cleanRange);
    }

    public Object[] updateAndEvaluate(Integer command, Integer p2gAngleInMin, Integer p2gDst, Integer nne, Integer ene, Integer ese, Integer sse, Integer ssw, Integer wsw, Integer wnw, Integer nnw) {
        Boolean botOn;
        Boolean botCleaning;
        Integer angleInMin;
        Integer dst;
        if (((((((((((((((((((((0 <= command && command <= 3) && 0 <= p2gAngleInMin) && p2gAngleInMin <= 21599) && p2gDst >= 0) && 0 <= nne) && nne <= maxMsrblDst) && 0 <= ene) && ene <= maxMsrblDst) && 0 <= ese) && ese <= maxMsrblDst) && 0 <= sse) && sse <= maxMsrblDst) && 0 <= ssw) && ssw <= maxMsrblDst) && 0 <= wsw) && wsw <= maxMsrblDst) && 0 <= wnw) && wnw <= maxMsrblDst) && 0 <= nnw) && nnw <= maxMsrblDst)) {
            
            cbotcontrollercore.readGoalPosAndSensors(p2gAngleInMin, p2gDst, nne, ene, ese, sse, ssw, wsw, wnw, nnw);
            
            switch (command) {
                case 0:
                    cbotcontrollercore.standBy();
                    break;
                case 1:
                    cbotcontrollercore.goToPosAndClean();
                    break;
                case 2:
                    cbotcontrollercore.goToPosAndNoClean();
                    break;
                case 3:
                    if (p2gDst == 0) {
                        cbotcontrollercore.standBy();
                    } else {
                        cbotcontrollercore.goToPosAndNoClean();
                    }
                    break;
                default:
                    cbotcontrollercore.standBy();
            }
            Object[] out = cbotcontrollercore.getInstr4Bot();
            botOn = (Boolean) out[0];
            botCleaning = (Boolean) out[1];
            angleInMin = (Integer) out[2];
            dst = (Integer) out[3];
        } else {
            botOn = false;
            botCleaning = false;
            angleInMin = 0;
            dst = 0;
        }
        return new Object[]{botOn, botCleaning, angleInMin, dst};
    }

    public CBotControllerCore cbotcontrollercore() {
        return cbotcontrollercore;
    }
}
