/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package characters.robot;

import characters.robot.ProximSensors;

/**
 *
 * @author Ján
 */
public class CBotControllerCore {

    // constants of Implementation: CBotControllerCore_i
    public static Integer EV_STEP = 1;
    public static Integer EV_START = 100;
    // variables of Implementation: CBotControllerCore_i
    private Boolean isOn;
    private Boolean isCleaning;
    private Boolean willBeOn;
    private Boolean willClean;
    private Integer goalAngle;
    private Integer goalDst;
    private Integer pos2goAngle;
    private Integer pos2goDst;
    private Integer evDst;
    private Integer evAngle;
    //Imported machines
    private ProximSensors proximsensors;
    // scalar formal parameters
    private Integer maxMsrblDst;
    private Integer safeDstCl;
    private Integer safeDstMov;
    private Integer cleanRange;

    public CBotControllerCore(Integer maxMsrblDst, Integer safeDstCl, Integer safeDstMov, Integer cleanRange) {
        this.maxMsrblDst = maxMsrblDst;
        this.safeDstCl = safeDstCl;
        this.safeDstMov = safeDstMov;
        this.cleanRange = cleanRange;
        this.proximsensors = new ProximSensors(maxMsrblDst);
        isOn = false;
        isCleaning = false;
        willBeOn = false;
        willClean = false;
        goalAngle = 0;
        goalDst = 0;
        pos2goAngle = 0;
        pos2goDst = 0;
        evDst = 0;
        evAngle = 0;
    }

    public Object[] getInstr4Bot() {
        Boolean botOn;
        Boolean botCleaning;
        Integer angleInMin;
        Integer dst;
        isOn = willBeOn;
        isCleaning = willClean;
        botOn = willBeOn;
        botCleaning = willClean;
        angleInMin = pos2goAngle;
        dst = pos2goDst;
        return new Object[]{botOn, botCleaning, angleInMin, dst};
    }

    public void readGoalPosAndSensors(Integer angleInMin, Integer dst, Integer nne, Integer ene, Integer ese, Integer sse, Integer ssw, Integer wsw, Integer wnw, Integer nnw) {
        if ((((((((((((((((((0 <= angleInMin && angleInMin <= 21599) && 0 <= nne) && nne <= maxMsrblDst) && 0 <= ene) && ene <= maxMsrblDst) && 0 <= ese) && ese <= maxMsrblDst) && 0 <= sse) && sse <= maxMsrblDst) && 0 <= ssw) && ssw <= maxMsrblDst) && 0 <= wsw) && wsw <= maxMsrblDst) && 0 <= wnw) && wnw <= maxMsrblDst) && 0 <= nnw) && nnw <= maxMsrblDst)) {
            goalAngle = angleInMin;
            goalDst = dst;
            proximsensors.readSensors(nne, ene, ese, sse, ssw, wsw, wnw, nnw);
        } else {
            goalAngle = 0;
            goalDst = 0;
            proximsensors.readSensors(0, 0, 0, 0, 0, 0, 0, 0);
        }
        willBeOn = false;
        willClean = false;
        pos2goDst = 0;
        pos2goAngle = 0;
    }

    public void standBy() {
        isOn = false;
        isCleaning = false;
        willBeOn = false;
        willClean = false;
        goalAngle = 0;
        goalDst = 0;
        pos2goAngle = 0;
        pos2goDst = 0;
        proximsensors.readSensors(0, 0, 0, 0, 0, 0, 0, 0);
        evDst = 0;
    }

    public void goToPosAndClean() {
        willBeOn = true;
        {
            Boolean allClr;
            allClr = proximsensors.allClear(safeDstCl);
            if (isCleaning == true) {
                if (allClr == false) {
                    pos2goDst = 0;
                    pos2goAngle = 0;
                    evDst = 0;
                    evAngle = 0;
                } else {
                    if (goalDst == 0) {
                        pos2goDst = goalDst;
                        pos2goAngle = goalAngle;
                    } else {
                        if (evDst == 0) {
                            {
                                Boolean frClr;
                                Boolean leftClr;
                                Boolean rightClr;
                                frClr = proximsensors.frontClear(goalAngle, safeDstMov);
                                leftClr = proximsensors.frontClear((goalAngle + 16200) % 21600, safeDstMov);
                                rightClr = proximsensors.frontClear((goalAngle + 5400) % 21600, safeDstMov);
                                if (frClr == true) {
                                    pos2goDst = goalDst;
                                    pos2goAngle = goalAngle;
                                    evDst = 0;
                                } else {
                                    if (leftClr == true) {
                                        evDst = EV_START;
                                        evAngle = (goalAngle + 16200) % 21600;
                                        pos2goDst = evDst;
                                        pos2goAngle = evAngle;
                                    } else if (rightClr == true) {
                                        evDst = EV_START;
                                        evAngle = (goalAngle + 5400) % 21600;
                                        pos2goDst = evDst;
                                        pos2goAngle = evAngle;
                                    } else {
                                        pos2goDst = 0;
                                        pos2goAngle = 0;
                                        evDst = 0;
                                        evAngle = 0;
                                    }
                                }
                            }
                        } else {
                            {
                                Boolean frEvClr;
                                frEvClr = proximsensors.frontClear(evAngle, safeDstMov);
                                if (frEvClr == true) {
                                    pos2goDst = evDst;
                                    pos2goAngle = evAngle;
                                    if (evDst >= EV_STEP) {
                                        evDst = evDst - EV_STEP;
                                    }
                                } else {
                                    pos2goDst = 0;
                                    pos2goAngle = 0;
                                    evDst = 0;
                                    evAngle = 0;
                                }
                            }
                        }
                    }
                }
                if ((allClr == false || goalDst > cleanRange)) {
                    willClean = false;
                } else {
                    willClean = true;
                }
            } else {
                if ((goalDst <= cleanRange && allClr == true)) {
                    willClean = true;
                } else {
                    willClean = false;
                }
                if (goalDst == 0) {
                    pos2goDst = goalDst;
                    pos2goAngle = goalAngle;
                } else {
                    if (evDst == 0) {
                        {
                            Boolean frClr;
                            Boolean leftClr;
                            Boolean rightClr;
                            frClr = proximsensors.frontClear(goalAngle, safeDstMov);
                            leftClr = proximsensors.frontClear((goalAngle + 16200) % 21600, safeDstMov);
                            rightClr = proximsensors.frontClear((goalAngle + 5400) % 21600, safeDstMov);
                            if (frClr == true) {
                                pos2goDst = goalDst;
                                pos2goAngle = goalAngle;
                                evDst = 0;
                            } else {
                                if (leftClr == true) {
                                    evDst = EV_START;
                                    evAngle = (goalAngle + 16200) % 21600;
                                    pos2goDst = evDst;
                                    pos2goAngle = evAngle;
                                } else if (rightClr == true) {
                                    evDst = EV_START;
                                    evAngle = (goalAngle + 5400) % 21600;
                                    pos2goDst = evDst;
                                    pos2goAngle = evAngle;
                                } else {
                                    pos2goDst = 0;
                                    pos2goAngle = 0;
                                    evDst = 0;
                                    evAngle = 0;
                                }
                            }
                        }
                    } else {
                        {
                            Boolean frEvClr;
                            frEvClr = proximsensors.frontClear(evAngle, safeDstMov);
                            if (frEvClr == true) {
                                pos2goDst = evDst;
                                pos2goAngle = evAngle;
                                if (evDst >= EV_STEP) {
                                    evDst = evDst - EV_STEP;
                                }
                            } else {
                                pos2goDst = 0;
                                pos2goAngle = 0;
                                evDst = 0;
                                evAngle = 0;
                            }
                        }
                    }
                }
            }
        }
    }

    public void goToPosAndNoClean() {
        willBeOn = true;
        if (isCleaning == true) {
            willClean = false;
        }
        if (goalDst == 0) {
            pos2goDst = goalDst;
            pos2goAngle = goalAngle;
        } else {
            if (evDst == 0) {
                {
                    Boolean frClr;
                    Boolean leftClr;
                    Boolean rightClr;
                    frClr = proximsensors.frontClear(goalAngle, safeDstMov);
                    leftClr = proximsensors.frontClear((goalAngle + 16200) % 21600, safeDstMov);
                    rightClr = proximsensors.frontClear((goalAngle + 5400) % 21600, safeDstMov);
                    if (frClr == true) {
                        pos2goDst = goalDst;
                        pos2goAngle = goalAngle;
                        evDst = 0;
                    } else {
                        if (leftClr == true) {
                            evDst = EV_START;
                            evAngle = (goalAngle + 16200) % 21600;
                            pos2goDst = evDst;
                            pos2goAngle = evAngle;
                        } else if (rightClr == true) {
                            evDst = EV_START;
                            evAngle = (goalAngle + 5400) % 21600;
                            pos2goDst = evDst;
                            pos2goAngle = evAngle;
                        } else {
                            pos2goDst = 0;
                            pos2goAngle = 0;
                            evDst = 0;
                            evAngle = 0;
                        }
                    }
                }
            } else {
                {
                    Boolean frEvClr;
                    frEvClr = proximsensors.frontClear(evAngle, safeDstMov);
                    if (frEvClr == true) {
                        pos2goDst = evDst;
                        pos2goAngle = evAngle;
                        if (evDst >= EV_STEP) {
                            evDst = evDst - EV_STEP;
                        }
                    } else {
                        pos2goDst = 0;
                        pos2goAngle = 0;
                        evDst = 0;
                        evAngle = 0;
                    }
                }
            }
        }
    }

    public ProximSensors proximsensors() {
        return proximsensors;
    }
}
