/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package models;

import characters.AbstractCharacter;
import characters.Ninja;
import com.jme3.animation.AnimControl;
import com.jme3.asset.AssetManager;
import com.jme3.bullet.BulletAppState;
import com.jme3.bullet.control.BetterCharacterControl;
import com.jme3.bullet.control.RigidBodyControl;
import com.jme3.input.InputManager;
import com.jme3.math.Vector3f;
import com.jme3.scene.Node;
import com.jme3.scene.Spatial;

/**
 *
 * @author peter
 */
public class Tree extends Node {

    private Spatial spatial;
    private Node node;
    private BetterCharacterControl characterControl;

    public Tree(Node rootNode, BulletAppState bulletAppState, AssetManager assetManager, Vector3f position) {
        this.spatial = assetManager.loadModel("Models/Tree/Tree.mesh.xml");
        this.spatial.setLocalScale(15f);
        this.spatial.setLocalTranslation(0f, -5f, 0f);
        this.node = new Node(); // You can create a new node to wrap your player to adjust the location. (This allows you to solve issues with character sinking into floor, etc.)
        this.node.attachChild(spatial); // add it to the wrapper


        this.characterControl = new BetterCharacterControl(3f, 6f, 0.0f); // construct character. (If your character bounces, try increasing height and weight.)
        this.node.addControl(this.characterControl); // attach to wrapper

        // add to physics state
        bulletAppState.getPhysicsSpace().add(this.characterControl);
        bulletAppState.getPhysicsSpace().addAll(this.node);
        rootNode.attachChild(this.node); // add wrapper to root
        ((Node) rootNode.getChild("New Scene")).attachChild(this.node);

        bulletAppState.getPhysicsSpace().add(this.characterControl);

        // set basic physical properties:
        this.characterControl.setGravity(new Vector3f(0, -1000f, 0));
        this.characterControl.warp(position); // warp character into landscape at particular location

        rootNode.attachChild(this);

    }
}
